!define PROGNAME "protalker-boost"
!include "MUI2.nsh"
!include "FileFunc.nsh"
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_LANGUAGE "Japanese"
outFile "protalker-boost.exe"
name "protalker-boost"
RequestExecutionLevel "admin"
installDir "$PROGRAMFILES\protalker-boost"
function .onInit
;If we're already installed, re-installing without uninstalling first will break everything.
ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost" "UninstallString"
strcmp $r0 "" NotInstalled
;already installed, abort
messageBox MB_YESNO|MB_ICONEXCLAMATION "̃vÓAłɃCXg[Ă܂B܂Ã݂o[WACXg[Kv܂B낵łH" idno quit
ReadRegStr $R1 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost" "InstallLocation"
strcmp $r1 "" +2
strCpy $instdir $r1
CopyFiles $INSTDIR\uninstall.exe $TEMP
clearErrors
execWait '$TEMP\uninstall.exe _?=$INSTDIR'
delete "$temp\uninstall.exe"
ifErrors 0 +2
quit
clearErrors
goto notInstalled
quit:
quit
notInstalled:
functionEnd

section
setOutPath $INSTDIR
file "readme.txt"
file "utility.exe"
writeUninstaller $INSTDIR\uninstall.exe
setOutPath "$instdir\src"
file "tts_mgr.cpp"
file "tts_mgr.def"
file "utility.hsp"
file "sonic.c"
file "sonic.h"
file "setup.nsi"
file "make.bat"
setOutPath $sysdir
clearErrors
rename "tts_mgr.dll" "tts_mgr2.dll"
ifErrors errors noerror
errors:
messageBox MB_OK "G[͂܂BCXg[̓LZ܂B"
abort
noerror:
file "tts_mgr.dll"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost"                  "DisplayName" "protalker-boost"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost"                  "UninstallString" "$\"$INSTDIR\uninstall.exe$\""
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost"                  "InstallLocation" "$INSTDIR"
messageBox MB_OK "XN[[_[ċNĂB̌AOKNbNĂB"
createDirectory "$SMPROGRAMS\${PROGNAME}"
createShortCut "$SMPROGRAMS\${PROGNAME}\protalker-boost Utility.lnk" "$INSTDIR\utility.exe"
createShortCut "$SMPROGRAMS\${PROGNAME}\protalker-boost Readme.lnk" "$INSTDIR\readme.txt"
sectionEnd

section "Uninstall"
;Try deleting tts_mgr.old unconditionally.
delete "$sysdir\tts_mgr.old"
clearErrors
rename "$sysdir\tts_mgr.dll" "$sysdir\tts_mgr.old"
ifErrors errors 0
rename "$sysdir\tts_mgr2.dll" "$sysdir\tts_mgr.dll"
ifErrors errors noerror
errors:
messageBox MB_OK "G[͂܂BCXg[̓LZ܂B"
abort
noerror:
messageBox MB_OK "XN[[_[ċNĂB̌AOKNbNĂB"
delete "$sysdir\tts_mgr.old"
;The important part is uninstalled. Now the rest
delete "$SMPROGRAMS\${PROGNAME}\protalker-boost utility.lnk"
delete "$SMPROGRAMS\${PROGNAME}\protalker-boost Readme.lnk"
rmdir "$SMPROGRAMS\${PROGNAME}"
delete "$instdir\readme.txt"
delete "$instdir\utility.exe"
delete "$instdir\src\tts_mgr.cpp"
delete "$instdir\src\tts_mgr.def"
delete "$instdir\src\utility.hsp"
delete "$instdir\src\sonic.c"
delete "$instdir\src\sonic.h"
delete "$instdir\src\setup.nsi"
delete "$instdir\src\make.bat"
rmdir "$instdir\src"
delete $INSTDIR\uninstall.exe
rmdir "$instdir"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\protalker-boost"
sectionEnd
